Summary: The most widely used Web server on the Internet.
Name: apache
Version: 1.3.20
Release: RaQXTR_1C1
Group: System Environment/Daemons

%define mod_ssl_version 2.8.4-1.3.20
%define mod_perl_version 1.25
%define openssl_version 0.9.6b
%define mod_auth_pam_external_version 1.0a

Source0: ftp://ftp.apache.org/apache/dist/apache_%{version}.tar.gz
Source1: apache-index.html
Source2: poweredby.png
Source3: httpd.init
Source4: apache.logrotate
Source5: apache-access.conf
Source6: apache-httpd.conf
Source7: apache-srm.conf
Source8: ftp://ftp.cohprog.com/pub/apache/module/1.3.0/mod_bandwidth.c
Source9: mod_put.c
Source10: http://www.snert.com/Software/Throttle/mod_throttle208.tgz
Source11: openssl-%{openssl_version}.tar.gz
Source12: Makefile.certificate
Source13: openssl.cnf
Source15: mod_perl-%{mod_perl_version}.tar.gz
Source16: mod_casp2.c
Source17: dispint.h
Source18: mod_ssl-%{mod_ssl_version}.tar.gz
Source19: mod_auth_pam_external.tar.gz

Patch0: apache-1.3.11-apxs.patch
Patch1: apache_1.3.11-srvroot.patch
Patch2: apache_1.3.11-maxprocs.patch
Patch3: mod_ssl-2.5.0-1.3.11-usr1.patch
Patch4: apache_1.3.20-cobalt.patch
Patch6: mod_frontpage-apache_1.3.12-v1.3.1-C1.patch
Patch9: apache_1.3.12-casp2.patch
Patch10: apache_1.3.12-suexec.patch
Patch11: apache_1.3.12-reinit.patch
Patch12: apache_1.3.12-mmap.patch
Patch13: mod_ssl-2.8.2-1.3.19-memory-usr1.patch


Copyright: Freely distributable and usable
BuildRoot: /var/tmp/apache-root
Prereq: /sbin/chkconfig, /bin/mktemp, /bin/rm, grep, textutils
Provides: webserver

%description
Apache is a powerful, full-featured, efficient and freely-available
Web server. Apache is also the most popular Web server on the
Internet.

Install the apache package if you need a Web server.

%package admsrv
Group: System Environment/Daemons
Summary: Cobalt Administrative Webserver

%description admsrv
This package contains only the binary for the administrative webserver
that runs the Cobalt configuration web interface.  It shares the libraries
from the base apache install.

%package devel
Group: Development/Libraries
Summary: Development tools for the Apache Web server.
Obsoletes: secureweb-devel

%description devel
The apache-devel package contains the source code for the Apache
Web server and the APXS binary you'll need to build Dynamic
Shared Objects (DSOs) for Apache.

If you are installing the Apache Web server, and you want to be 
able to compile or develop additional modules for Apache, you'll 
need to install this package.

%package mod_perl
Group: System Envrionment/Daemons
Summary: A Perl interpreter for the Apache Web server.

%description mod_perl
Mod_perl incorporates a Perl interpreter into the Apache web
server, so that the Apache web server can directly execute Perl
code.  Mod_perl links the Perl runtime library into the Apache
web server and provides an object-oriented Perl interface for
Apache's C language API.  The end result is a quicker CGI script
turnaround process, since no external Perl interpreter has to
be started.

%package openssl
Group: System Envrionment/Utilites
Summary: Provides the utilities for generating, manipulating and testing certs.

%description openssl
A subset of the openssl utilities used to manipulate certificates. They also
provide a way to generate new certificate requests, sign certifiate requests
and test certificates.

%prep
%setup -q -c -n apache -a 11 -a 15 -a 19 -a 18
cp %{SOURCE16} %{SOURCE17} apache_%{version}/src/modules/extra/

# patch apache
cd apache_%{version}
%patch0 -p1 -b .apxs
%patch1 -p1 -b .srvroot
%patch2 -p1 -b .maxprocs
%patch4 -p1 -b .cobalt
%patch6 -p1 -b .fpx
%patch10 -p1 -b .suexec
%patch11 -p1 -b .tzset
%patch12 -p1 -b .mmap
cd ..

# patch mod_ssl a little
cd mod_ssl-%{mod_ssl_version}
%patch3 -p1 -b .usr1
%patch13 -p0 -b .usr1-memory
cd ..

%build
# build OpenSSL
cd openssl-%{openssl_version}
./Configure linux-elf 
make depend
make 
cd ..

## BEGIN ADMIN WEBSERVER

echo "Building Admin Webserver...."

export OPTIM="$RPM_OPT_FLAGS"
export LIBS="-lpam -ldl"
# only use BIG_SECURITY_HOLE if you want apache to be able to run 
# as root.
export CFLAGS="-DBIG_SECURITY_HOLE -DCOBALT_RAQ_LED"
export SSL_SDBM="yes"

# configure mod_ssl
cd mod_ssl-%{mod_ssl_version}
./configure \
	--enable-shared=ssl \
	--with-apache=../apache_%{version} \
	--with-ssl=../openssl-%{openssl_version} 

# configure mod_perl/apache
cd ../mod_perl-%{mod_perl_version}
	perl Makefile.PL \
	USE_APACI=1 \
	DO_HTTPD=1 \
	EVERYTHING=1 \
	SSL_BASE=../openssl-%{openssl_version} \
        APACHE_SRC=../apache_%{version}/src \
        APACHE_PREFIX=/usr \
        APACI_ARGS="--prefix=/usr,--with-perl=/usr/bin/perl,--libexecdir=/usr/lib/apache,--sysconfdir=/etc/httpd/conf,--serverroot=/etc/httpd,--datadir=/usr/doc/httpd,--includedir=/usr/include/apache,--logfiledir=/var/log/httpd,--localstatedir=/var,--runtimedir=/var/run,--enable-module=most,--enable-shared=max,--disable-shared=perl,--disable-module=auth_dbm,--disable-rule=WANTHSREGEX,--enable-suexec,--suexec-caller=httpd,--suexec-userdir=web,--suexec-uidmin=99,--with-layout=RedHat,--activate-module=src/modules/extra/mod_casp2.o,--enable-shared=casp2,--activate-module=src/modules/frontpage/mod_frontpage.o,--enable-shared=frontpage,--fpexec-caller=httpd,--fpexec-uidmin=99,--server-uid=httpd,--server-gid=httpd,--fpexec-fpuser=bin,--fpexec-fpgroup=bin"

make
	
# Configure mod_auth_pam_external
cd ../mod_auth_pam_external-%{mod_auth_pam_external_version}
gcc -shared $RPM_BUILD_OPTS -I../apache_%{version}/src/include \
    -I ../apache_%{version}/src/os/unix -fPIC -DEAPI \
    mod_auth_pam_external.c -o mod_auth_pam_external.so -ldl -lpam
make -C authenticate

## END ADMIN WEBSERVER

## BEGIN PUBLIC WEBSERVER

echo "Building Public Webserver...."

# ok, let's move the httpd binary to a safe location and rebuild
# apache and create a safe public webserver binary...
cp ../apache_%{version}/src/httpd /var/tmp/httpd.admsrv

export OPTIM="$RPM_OPT_FLAGS"
export LIBS="-lpam -ldl"
export CFLAGS="-DCOBALT_RAQ_LED"
export SSL_SDBM="yes"

# configure mod_ssl
cd ../mod_ssl-%{mod_ssl_version}
./configure \
        --enable-shared=ssl \
        --with-apache=../apache_%{version} \
        --with-ssl=../openssl-%{openssl_version} 

# configure mod_perl/apache
cd ../mod_perl-%{mod_perl_version}
make clean
        perl Makefile.PL \
        USE_APACI=1 \
        DO_HTTPD=1 \
        EVERYTHING=1 \
        SSL_BASE=../openssl-%{openssl_version} \
        APACHE_SRC=../apache_%{version}/src \
        APACHE_PREFIX=/usr \
        APACI_ARGS="--prefix=/usr,--with-perl=/usr/bin/perl,--libexecdir=/usr/lib/apache,--sysconfdir=/etc/httpd/conf,--serverroot=/etc/httpd,--datadir=/usr/doc/httpd,--includedir=/usr/include/apache,--logfiledir=/var/log/httpd,--localstatedir=/var,--runtimedir=/var/run,--enable-module=most,--enable-shared=max,--disable-shared=perl,--disable-module=auth_dbm,--disable-rule=WANTHSREGEX,--enable-suexec,--suexec-caller=httpd,--suexec-userdir=web,--suexec-uidmin=99,--with-layout=RedHat,--activate-module=src/modules/extra/mod_casp2.o,--enable-shared=casp2,--activate-module=src/modules/frontpage/mod_frontpage.o,--enable-shared=frontpage,--fpexec-caller=httpd,--fpexec-uidmin=99,--server-uid=httpd,--server-gid=httpd,--fpexec-fpuser=bin,--fpexec-fpgroup=bin"

make
        
# Configure mod_auth_pam_external
cd ../mod_auth_pam_external-%{mod_auth_pam_external_version}
make clean
gcc -shared $RPM_BUILD_OPTS -I../apache_%{version}/src/include \
    -I ../apache_%{version}/src/os/unix -fPIC -DEAPI \
    mod_auth_pam_external.c -o mod_auth_pam_external.so -ldl -lpam
make -C authenticate
#### END PUBLIC WEBSERVER

%install

rm -rf $RPM_BUILD_ROOT

# install openssl bits
cd openssl-%{openssl_version}
make install INSTALLTOP=$RPM_BUILD_ROOT/usr
# remove stuff we don't want from OpenSSL
rm -fr $RPM_BUILD_ROOT/usr/{certs,include,private}
rm $RPM_BUILD_ROOT/usr/lib/*.a
mkdir -p $RPM_BUILD_ROOT/usr/sbin
strip $RPM_BUILD_ROOT/usr/bin/openssl
mv $RPM_BUILD_ROOT/usr/bin/openssl $RPM_BUILD_ROOT/usr/sbin
cp test/ssltest $RPM_BUILD_ROOT/usr/sbin/
cp $RPM_SOURCE_DIR/openssl.cnf $RPM_BUILD_ROOT/usr/lib/openssl.cnf
rm -rf $RPM_BUILD_ROOT/usr/bin
cd ..

# now install apache functionality
cd apache_%{version}
make install root=$RPM_BUILD_ROOT
strip $RPM_BUILD_ROOT/usr/sbin/httpd
#strip --strip-debug $RPM_BUILD_ROOT/usr/lib/apache/*so
# mod_frontpage's fpexec
install -m04755 src/modules/frontpage/fpexec $RPM_BUILD_ROOT/usr/sbin/fpexec
cd ..

# install the admin server
cp /var/tmp/httpd.admsrv $RPM_BUILD_ROOT/usr/sbin/httpd.admsrv
strip $RPM_BUILD_ROOT/usr/sbin/httpd.admsrv

# install mod_auth_pam_external.so
cd mod_auth_pam_external-%{mod_auth_pam_external_version}
strip --strip-debug mod_auth_pam_external.so
cp mod_auth_pam_external.so $RPM_BUILD_ROOT/usr/lib/apache
install -m4775 authenticate/authenticate $RPM_BUILD_ROOT/usr/lib
cd ..

# install mod_perl
cd mod_perl-%{mod_perl_version}
make pure_install PREFIX=$RPM_BUILD_ROOT/usr

# remove apachectl; we have our own SYSV init stuff
rm $RPM_BUILD_ROOT/usr/sbin/apachectl
rm $RPM_BUILD_ROOT/usr/man/man8/apachectl.8

# install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/apache.logrotate \
	$RPM_BUILD_ROOT/etc/logrotate.d/apache

ln -s ../../var/log/httpd $RPM_BUILD_ROOT/etc/httpd/logs
ln -s ../../usr/lib/apache $RPM_BUILD_ROOT/etc/httpd/modules

mkdir -p $RPM_BUILD_ROOT/etc/admserv
ln -s ../../var/log/httpd $RPM_BUILD_ROOT/etc/admserv/logs
ln -s ../../usr/lib/apache $RPM_BUILD_ROOT/etc/admserv/modules

find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl5" | \
	xargs perl -pi -e "s|/usr/local/bin/perl5|/usr/bin/perl|g;"
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl" | \
	xargs perl -pi -e "s|/usr/local/bin/perl|/usr/bin/perl|g;"

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/usr/lib/authenticate
/usr/lib/apache/
/etc/httpd/logs
/etc/httpd/modules
/etc/admserv/logs
/etc/admserv/modules
%config /etc/logrotate.d/apache

/usr/man/man1/*
/usr/man/man8/ab.8*
/usr/man/man8/httpd.8*
/usr/man/man8/logresolve.8*
/usr/man/man8/rotatelogs.8*
/usr/man/man8/suexec.8*

/usr/sbin/ab
/usr/sbin/fpexec
/usr/sbin/httpd
/usr/sbin/logresolve
/usr/sbin/rotatelogs
%attr(4711,root,root) /usr/sbin/suexec
/usr/bin/*

%attr(-,nobody,nobody) %dir /var/cache/httpd
%dir /var/log/httpd

%files admsrv
%defattr(-,root,root)
/usr/sbin/httpd.admsrv

%files devel
%defattr(-,root,root)
/usr/include/apache
/usr/sbin/apxs
/usr/man/man8/apxs.8*

%files mod_perl
%defattr(-,root,root)
/usr/lib/perl5/site_perl/5.005/i386-linux/auto/Apache
/usr/lib/perl5/site_perl/5.005/i386-linux/auto/mod_perl
/usr/lib/perl5/site_perl/5.005/i386-linux/Bundle/*
/usr/lib/perl5/site_perl/5.005/i386-linux/Apache
/usr/lib/perl5/site_perl/5.005/i386-linux/*.pod
/usr/lib/perl5/site_perl/5.005/i386-linux/*.pm
/usr/lib/perl5/site_perl/5.005/i386-linux/*.PL
/usr/lib/perl5/man/man3/*

%files openssl
%defattr(-,root,root)
%config /usr/lib/openssl.cnf
/usr/sbin/openssl
/usr/sbin/ssltest

%changelog
* Thu Jul 12 2001 Jeff Lovell <jeffrey.lovell@sun.com>
- 1.3.20-RaQXTR_1C1
- remove bsafe
- upgrade openssl to 0.9.6b
- upgrade mod_perl to 1.25
- upgrade mod_ssl to 2.8.4-1.3.20
- replace mod_auth_pam with mod_auth_pam_external
- move initscripts into appropiate RPMS

* Fri May 25 2001 Patrick Baltz <patrick.baltz@sun.com>
- patch to make mod_ssl not use gobs of memory on USR1 restarts

* Wed Aug 09 2000 Will DeHaan <will@cobalt.com>
- Force fpexec umask to override ssl-generation umask of 077

* Thu Jun 08 2000 Adrian Sun <asun@cobalt.com>
- bleah. got logrotate entries wrong.

* Wed May 24 2000 Adrian Sun <asun@cobalt.com>
- added back in split_logs entries in logrotate. added in 
  rotation of suexec.log

* Wed May 24 2000 Will DeHaan <will@cobalt.com>
- changed BASEVERSION to plug Cobalt

* Tue May 09 2000 Adrian Sun <asun@cobalt.com>
- hmm. the apache-mod_perl stuff got lost. add it back in.

* Thu Apr 27 2000 Will DeHaan <will@cobalt.com>
- mod_casp2 integration

* Sun Apr 23 2000 Will DeHaan <will@cobalt.com>
- Frontpage/suexec interaction fixed
- any user authentication (euid patch) by Adrian Sun

* Sat Apr 15 2000 Will DeHaan <will@cobalt.com>
- added Christof Pohl's "Improved mod_frontpage" v1.3.1 
- mod_frontpage patch modified for Cobalt apache/configure mods

* Wed Apr 05 2000 Adrian Sun <asun@cobalt.com>
- integrated bsafe library with rsaref shim.

* Thu Feb 10 2000 Preston Brown <pbrown@redhat.com>
- improved default index.html.

* Thu Feb 03 2000 Preston Brown <pbrown@redhat.com>
- strip dynamically loadable modules.

* Mon Feb 02 2000 Zach Brown <zab@redhat.com>
- add phhttpd 'Tunnel' directive and code to use it

* Mon Jan 31 2000 Cristian Gafton <gafton@redhat.com>
- rebuild to fix depenencies

* Tue Jan 25 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 1.3.11
- deal with the fact that RPM now gzips man pages

* Wed Jan 12 2000 Preston Brown <pbrown@redhat.com>
- new poweredby.png w/new logo
- apxs.8 man page moved to devel archive (#6661)
- don't remove old logfiles on package de-install (#8268)
- more updates to logrotate to avoid spurious cron mail (#8110)

* Mon Jan 10 2000 Preston Brown <pbrown@redhat.com>
- mod_throttle added; mod_bandwidth updated.

* Mon Dec 17 1999 Dale Lovelace <dale@redhat.com>
- Add configuration for mod_put to httpd.conf

* Mon Dec 06 1999 Preston Brown <pbrown@redhat.com>
- documentation cleanups in httpd.conf (#5357, #6655)
- fixed logrotate script to ignore error if no apache running (#7074)

* Wed Nov 10 1999 Jeff Johnson <jbj@redhat.com>
- add put module.

* Thu Nov 04 1999 Preston Brown <pbrown@redhat.com>
- make suexec non-suid.  People can enable it if they wish themselves.
- somehow the unified httpd.conf got trashed.  fixed.
- manual is now a subpackage
- point to /usr/share/magic as the magic file location; don't use the
  apache-specific one.
- fix apxs module installation issues (#5650)


* Tue Sep 21 1999 Bill Nottingham <notting@redhat.com>
- move DSO in httpd.conf to after ServerRoot

* Mon Sep 20 1999 Preston Brown <pbrown@redhat.com>
- it is httpd stop, not httpsd stop (# 5254)
- suexec added (# 5257)

* Thu Sep 09 1999 Preston Brown <pbrown@redhat.com>
- remove apachectl man page (# 4459)

* Fri Aug 27 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 1.3.9
- fix bug # 3680 (suexec docroot was wrong)
- fix bug # 2378 (logrotate with -USR1 not -HUP)
- fix bug # 3548 (logrotate complains if apache not running)
- httpd.conf is now in the unified apache format as distributed

* Mon Aug 16 1999 Bill Nottingham <notting@redhat.com>
- initscript munging

* Sat May 21 1999 Bill Nottingham <notting@redhat.com>
- fix broken link in index.html

* Wed Apr 07 1999 Bill Nottingham <notting@redhat.com>
- allow indexes in /doc

* Tue Apr 06 1999 Preston Brown <pbrown@redhat.com>
- strip binaries

* Mon Apr 05 1999 Preston Brown <pbrown@redhat.com>
- prerequire /bin/rm, added /doc path pointing to /usr/doc for localhost

* Fri Mar 26 1999 Preston Brown <pbrown@redhat.com>
- updated log rotating scripts to not complain if logs aren't present.

* Thu Mar 25 1999 Preston Brown <pbrown@redhat.com>
- fixed up path to perl

* Wed Mar 24 1999 Preston Brown <pbrown@redhat.com>
- updated init script to conform to new standards
- upgraded to 1.3.6, fixed apxs patch

* Mon Mar 22 1999 Preston Brown <pbrown@redhat.com>
- clean up logfiles on deinstallation

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Fri Mar 12 1999 Cristian Gafton <gafton@redhat.com>
- added mod_bandwidth
- updated to 1.3.4
- prereq mailcap

* Fri Dec 18 1998 Cristian Gafton <gafton@redhat.com>
- added patch to disable building support for ndbm
- build against glibc 2.1

* Mon Oct 12 1998 Cristian Gafton <gafton@redhat.com>
- updated to 1.3.3 to catch up with bug fixes
- added the /usr/bin/* binaries to the spec file list

* Fri Sep 25 1998 Cristian Gafton <gafton@redhat.com>
- change ownership of cache dir to nobody
- added "Red Hat" to the server string
- updated to version 1.3.2
- fixed all references to httpsd in config files

* Fri Sep 04 1998 Cristian Gafton <gafton@redhat.com>
- small fixes to the spec file
- patch to handle correctly the -d <newroot> option
- leave out the .usr.src.apache_%{version} for now

* Thu Sep 03 1998 Preston Brown <pbrown@redhat.com>
- patched apxs not to bomb out if it can't find httpd

* Wed Sep 02 1998 Preston Brown <pbrown@redhat.com>
- upgraded to apache 1.3.1.
- Heavy rewrite.
- changed providing a_web_server to just webserver.  Humor is not an option.

* Mon Aug 10 1998 Erik Troan <ewt@redhat.com>
- updated to build as non-root user
- added patch to defeat header dos attack

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed May 06 1998 Cristian Gafton <gafton@redhat.com>
- fixed the default config files to be more paranoid about security

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- fixed init script
- added index.htm to the list of acceptable indexes

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- updated to 1.2.6
- added post script to install htm extension for text/html into
  /etc/mime.types

* Wed Apr 22 1998 Michael K. Johnson <johnsonm@redhat.com>
- enhanced sysv init script

* Tue Jan 06 1998 Erik Troan <ewt@redhat.com>
- updated to 1.2.5, which includes many security fixes

* Wed Dec 31 1997 Otto Hammersmith <otto@redhat.com>
- fixed overkill on http.init stop

* Wed Dec 31 1997 Erik Troan <ewt@redhat.com>
- added patch for backslash DOS attach

* Thu Nov 06 1997 Donnie Barnes <djb@redhat.com>
- added htdigest binary to file list

* Mon Nov 03 1997 Donnie Barnes <djb@redhat.com>
- made the default index.html be config(noreplace) so we no longer
  blow away other folks' index.html

* Wed Oct 29 1997 Donnie Barnes <djb@redhat.com>
- added chkconfig support
- added restart|status options to initscript
- renamed httpd.init to httpd

* Tue Oct 07 1997 Elliot Lee <sopwith@redhat.com>
- Redid spec file, patches, etc. from scratch.
